*
* Demoprogramm - Version fr andere Compiler
*
* Die Programmstruktur wurde weitestgehend so belassen, wie
* in der Version fr FCO, so da ein mglichst exakter
* Vergleich durchgefhrt werden kann.
*

*** Hauptprozedur

speed = .f.                      && Flag fr Beschleunigung

  set scoreboard off
  set cursor off

  do title                       && Titelbildschirm anzeigen

  do while .t.                   && Haupt-Programmschleife
    choice = main_menu()         && Men-Auswahl holen

    do case                      && Funktionsauswahl
      case choice = 1
        do schltg
       case choice = 2
        do schltf
      case choice = 3
        do dbtest
      case choice = 4
        do xudftest
      case choice = 5
        clear
        set cursor on
        quit
    endcase

  enddo

procedure schltg                 && Schleifen-Test mit long-Zhlvariable

  clear
  @  0, 0 to 24,79 double
  @  2,11 say "Demoprogramm fr andere Compiler - Schleifentest (Ganzzahl)"
  @  3,11 say ""

  @  5,17 say "Andere Compiler  knnen den  Variablentyp long"
  @  6,17 say "nicht verarbeiten  -  aus diesem Grund ist der"
  @  7,17 say "Test unfair, da er mit Fliekomma arbeitet!"

  @  8,17 say "In diesem Programmteil wird eine  leere FOR..."
  @  9,17 say "NEXT-Schleife  300.000-mal  durchlaufen.   Als"
  @ 10,17 say "Zhlvariable dient  hier eine float-Zahl.  Bei"
  @ 11,17 say "FCO kann stattdessen eine  long-Zahl benutzt"
  @ 12,17 say "werden. Das reicht in Schleifen meistens  aus,"
  @ 13,17 say "ergibt aber dafr sehr hohe Geschwindigkeiten."
  @ 14,17 say "Bitte merken Sie sich den  Zeitbedarf fr Ver-"
  @ 15,17 say "gleiche mit FCO."

  @ 17,17 say "Anfangszeit:"
  @ 18,17 say "Endzeit:"
  @ 19,17 say "Dauer:"

  @ 22,17 say "ESC=Abbruch, andere Taste = Start..."

  if inkey(0) = 27
    return
  endif

  @ 22,17 say "Test luft...                       "

  t_anf = time()
  @ 17,30 say t_anf

  for i = 1 to 300000
  next

  t_end = time()
  @ 18,30 say t_end
  @ 19,30 say t_diff(t_anf, t_end)  picture "99999999"
  @ 19,39 say "Sekunden"

  @ 22,17 say "Zurck zum Men mit beliebiger Taste..."

  inkey(0)


procedure schltf                 && Schleifen-Test mit Fliekomma-Zahl

  private i, t_anf, t_end

  clear
  @  0, 0 to 24,79 double
  @  2,10 say "Demoprogramm fr andere Compiler - Schleifentest (Fliekomma)"
  @  3,10 say ""
  @  5,17 say "In  diesem  Programmteil wird eine leere FOR..."
  @  6,17 say "NEXT-Schleife 30.000-mal durchlaufen. Als Zhl-"
  @  7,17 say "variable dient eine Fliekomma-Zahl."
  @  8,17 say "Dieser Variablen-Typ ist auch in anderen dBase-"
  @  9,17 say "Compilern verfgbar,  so da dieser Test direkt"
  @ 10,17 say "verglichen werden kann."
  @ 12,17 say "Bitte  merken  Sie sich den Zeitbedarf fr Ver-"
  @ 13,17 say "gleiche mit FCO."

  @ 15,17 say "Anfangszeit:"
  @ 16,17 say "Endzeit:"
  @ 18,17 say "Dauer:"

  @ 22,17 say "ESC=Abbruch, andere Taste = Start..."

  if inkey(0) = 27
    return
  endif

  @ 22,17 say "Test luft...                       "

  t_anf = time()
  @ 15,30 say t_anf

  for i = 1 to 30000
  next

  t_end = time()
  @ 16,30 say t_end
  @ 18,30 say t_diff(t_anf, t_end) picture "99999999"
  @ 18,39 say "Sekunden"
  @ 22,17 say "Zurck zum Men mit beliebiger Taste..."
  inkey(0)

function tim_to_secs         && Hilfsfunktion fr t_diff()
  parameters tim
  return val(substr(tim,1,2)) * 3600 + val(substr(tim,4,2)) * 60 + val(substr(tim,7,2))

function t_diff              && Zeit-Differenz berechnen
  parameters anf, end
  return tim_to_secs(end) - tim_to_secs(anf)

function main_menu          && Hauptmen

private sel

  clear
  @  0,0 to 24,79 double
  @  2,17 say    " Demoprogramm fr andere Compiler - Auswahlmen"
  @  3,17 say    ""
  @  5,24 prompt "1) Schleifen-Test (Ganzzahl)      "
  @  6,24 prompt "2) Schleifen-Test (Fliekommazahl)"
  @  7,24 prompt "3) Datenbank-Test                 "
  @  8,24 prompt "4) Index-Test mit UDF             "
  @ 10,24 prompt "X) Programm-Ende                  "
  menu to sel
  return sel

procedure title                  && Titelbildschirm

private x, t

  clear
  for x = 0 to 11
    @ x, x * 2 to 24 - x, 79 - x * 2 double
    @ 24,12 say "Wenn Ihnen das zu langsam ist, drcken Sie eine Taste..."
    do delay with 5000
  next
  @ 12, 28 say "NICHT   F  C  O  ! ! !"
  do delay with 100000

procedure delay                  && Zeitverzgerung
  parameters l

  private i

  if inkey() <> 0                && "Beschleunigungstaste"
    speed = .t.
  endif

  if speed
    l = l / 100
  endif

  for i = 1 to l
  next

procedure dbtest                 && Kombinierter Dateitest

  private i, txt, tt_anf, t_anf, t_end

  clear
  @  0, 0 to 24,79 double
  @  2,15 say "Demoprogramm fr andere Compiler - Datenbank-Test"
  @  3,15 say ""
  @  5,17 say "In  diesem  Programmteil wird eine Datei ange-"
  @  6,17 say "legt,  in die 1000  Stze mit der Zeichenfolge"
  @  7,17 say "'ABC...XYZ', 'BCD...YZA' usw. eingetragen wer-"
  @  8,17 say "den.  Anschlieend  wird  noch ein Satz mit 26"
  @  9,17 say "Zeichen 'X'angefgt.  Danach  wird eine Index-"
  @ 10,17 say "Datei angelegt  und abschlieend  der Satz mit"
  @ 11,17 say "26 Zeichen 'X' durch LOCATE aufgesucht."

  @ 13,17 say "Bitte  merken Sie sich den Zeitbedarf fr Ver-"
  @ 14,17 say "gleiche mit FCO."

  @ 18,17 say "Anfangszeit:"
  @ 19,17 say "Endzeit:"
  @ 20,17 say "Dauer:"
  @ 21,17 say "Gesamtdauer:"

  @ 22,17 say "ESC=Abbruch, andere Taste = Start..."

  if inkey(0) = 27
    return
  endif

  @ 23,17 say "Test luft...                       "

  if file("test.dbf")
    erase test.dbf
  endif
  if file("testx.ntx")
    erase testx.ntx
  endif

  @ 17,30 say "Datei anlegen"
  tt_anf = time()
  t_anf  = tt_anf
  @ 18,30 say tt_anf
  do build

  use test

  txt = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

  for i = 1 to 1000
    append blank
    replace test->ftext with txt
    txt = substr(txt,2,25) + substr(txt,1,1)
  next

  append blank
  replace test->ftext with replicate("X",26)

  t_end = time()
  @ 19,30 say t_end
  @ 20,30 say t_diff(t_anf, t_end) picture "99999999"

  @ 17,45 say "Index aufbauen"

  t_anf = time()
  @ 18,45 say t_anf

  index on ftext to testx
  set index to testx

  t_end = time()
  @ 19,45 say t_end
  @ 20,45 say t_diff(t_anf, t_end) picture "99999999"

  @ 17,60 say "LOCATE ausfhren"
  t_anf = time()
  @ 18,60 say t_anf

  go top
  locate for test->ftext = replicate("X",26)

  t_end = time()
  @ 19,60 say t_end
  @ 20,60 say t_diff(t_anf, t_end) picture "99999999"
  @ 21,60 say t_diff(tt_anf,t_end) picture "99999999"
  @ 23,17 say "Zurck zum Men mit beliebiger Taste..."

  inkey(0)
  close databases

procedure xudftest               && Index-Test mit UDF

  private i, txt, tt_anf, t_anf, t_end

  clear
  @  0, 0 to 24,79 double
  @  2,13 say "Demoprogramm fr andere Compiler - Index-Test mit UDF"
  @  3,13 say ""
  @  5,17 say "In  diesem  Programmteil wird eine Datei ange-"
  @  6,17 say "legt,  in die 5000  Stze mit der Zeichenfolge"
  @  7,17 say "'ABC...XYZ', 'BCD...YZA' usw. eingetragen wer-"
  @  8,17 say "den.  Anschlieend  wird  eine Index-Datei mit"
  @  9,17 say "einer eigenen Funktion (UDF) im Index-Ausdruck"
  @ 10,17 say "angelegt."

  @ 12,17 say "Bitte  merken Sie sich den Zeitbedarf fr Ver-"
  @ 13,17 say "gleiche mit FCO."

  @ 18,17 say "Anfangszeit:"
  @ 19,17 say "Endzeit:"
  @ 20,17 say "Dauer:"
  @ 21,17 say "Gesamtdauer:"

  @ 22,17 say "ESC=Abbruch, andere Taste = Start..."

  if inkey(0) = 27
    return
  endif

  @ 23,17 say "Test luft...                       "

  if file("test.dbf")
    erase test.dbf
  endif
  if file("testx.ntx")
    erase testx.ntx
  endif

  @ 17,30 say "Datei anlegen"
  tt_anf = time()
  t_anf  = tt_anf
  @ 18,30 say tt_anf

  do build

  use test

  txt = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"

  for i = 1 to 5000
    append blank
    replace test->ftext with txt
    txt = substr(txt,2,25) + substr(txt,1,1)
  next

  t_end = time()
  @ 19,30 say t_end
  @ 20,30 say t_diff(t_anf, t_end) picture "99999999"

  @ 17,45 say "Index aufbauen"
  t_anf = time()
  @ 18,45 say t_anf

  index on cap_first(ftext) to testx

  t_end = time()
  @ 19,45 say t_end
  @ 20,45 say t_diff(t_anf, t_end) picture "99999999"
  @ 21,45 say t_diff(tt_anf,t_end) picture "99999999"

  @ 23,17 say "Zurck zum Men mit beliebiger Taste..."

  inkey(0)

  close databases

function cap_first      && UDF fr Index-Test
  parameters txt
  return upper(substr(txt,1,1)) + substr(txt,2,len(txt)-1)

procedure build         && Ersatz fr BUILD-Kommando von FCO
create temp
use temp
append blank
replace field_name with "FTEXT"
replace field_type with "C"
replace field_len with 26
replace field_dec with 0
close databases
create test from temp
close databases
erase temp.dbf

*** EOF ***
